﻿using System;
using System.Text.Json.Serialization;

namespace MakingAPostRequestWithBasicAuth
{
    public partial class Data
    {
        public override string ToString()
        {
            return $"{FirstName} {LastName} - {Age}";
        }

        [JsonPropertyName("firstName")]
        public string FirstName { get; set; }

        [JsonPropertyName("lastName")]
        public string LastName { get; set; }

        [JsonPropertyName("age")]
        public long Age { get; set; }
    }

    public partial class Headers
    {
        [JsonPropertyName("x-forwarded-proto")]
        public string XForwardedProto { get; set; }

        [JsonPropertyName("host")]
        public string Host { get; set; }

        [JsonPropertyName("content-length")]
        public long ContentLength { get; set; }

        [JsonPropertyName("authorization")]
        public string Authorization { get; set; }

        [JsonPropertyName("content-type")]
        public string ContentType { get; set; }

        [JsonPropertyName("user-agent")]
        public string UserAgent { get; set; }

        [JsonPropertyName("x-forwarded-port")]
        public long XForwardedPort { get; set; }
    }

    public class Json
    {
        [JsonPropertyName("firstName")]
        public string FirstName { get; set; }

        [JsonPropertyName("lastnName")]
        public string LastnName { get; set; }

        [JsonPropertyName("age")]
        public long Age { get; set; }
    }

    public class PersonResponse
    {
        public override string ToString()
        {
            return $"Response includes \n \t {Data.ToString()} \n \t Auth header: {Headers.Authorization}";
        }

        [JsonPropertyName("data")]
        public Data Data { get; set; }

        [JsonPropertyName("headers")]
        public Headers Headers { get; set; }

        [JsonPropertyName("json")]
        public Data Json { get; set; }

        [JsonPropertyName("url")]
        public Uri Url { get; set; }
    }
}
